Перем ВнутреннийСписок;  // Оригинальная коллекция
Перем Блокировка;           // Блокировка для синхронизации доступа

Функция Итератор() Экспорт
	Возврат ВнутреннийСписок.Итератор();
КонецФункции

Процедура ДляКаждого(Алгоритм) Экспорт
	
	Блокировка.Заблокировать();

	Попытка
		ВнутреннийСписок.ДляКаждого(Алгоритм);
	Исключение
		Блокировка.Разблокировать();
		ВызватьИсключение ПодробноеПредставлениеОшибки(ИнформацияОбОшибке());
	КонецПопытки;

	Блокировка.Разблокировать();

КонецПроцедуры

Функция Содержит(Элемент) Экспорт

	Блокировка.Заблокировать();

	Попытка
		Результат = ВнутреннийСписок.Содержит(Элемент);
	Исключение
		Блокировка.Разблокировать();
		ВызватьИсключение ПодробноеПредставлениеОшибки(ИнформацияОбОшибке());
	КонецПопытки;
	
	Блокировка.Разблокировать();

	Возврат Результат;

КонецФункции

Функция СодержитВсе(Коллекция) Экспорт

	Блокировка.Заблокировать();

	Попытка
		Результат = ВнутреннийСписок.СодержитВсе(Коллекция);
	Исключение
		Блокировка.Разблокировать();
		ВызватьИсключение ПодробноеПредставлениеОшибки(ИнформацияОбОшибке());
	КонецПопытки;
	
	Блокировка.Разблокировать();

	Возврат Результат;

КонецФункции

Функция Пусто() Экспорт

	Блокировка.Заблокировать();

	Попытка
		Результат = ВнутреннийСписок.Пусто();
	Исключение
		Блокировка.Разблокировать();
		ВызватьИсключение ПодробноеПредставлениеОшибки(ИнформацияОбОшибке());
	КонецПопытки;
	
	Блокировка.Разблокировать();

	Возврат Результат;
	
КонецФункции

Функция ПроцессорКоллекции() Экспорт
	Возврат ВнутреннийСписок.ПроцессорКоллекции();
КонецФункции

Функция Количество() Экспорт

	Блокировка.Заблокировать();

	Попытка
		Результат = ВнутреннийСписок.Количество();
	Исключение
		Блокировка.Разблокировать();
		ВызватьИсключение ПодробноеПредставлениеОшибки(ИнформацияОбОшибке());
	КонецПопытки;
	
	Блокировка.Разблокировать();

	Возврат Результат;

КонецФункции

Функция ВМассив() Экспорт

	Блокировка.Заблокировать();

	Попытка
		Результат = ВнутреннийСписок.ВМассив();
	Исключение
		Блокировка.Разблокировать();
		ВызватьИсключение ПодробноеПредставлениеОшибки(ИнформацияОбОшибке());
	КонецПопытки;
	
	Блокировка.Разблокировать();

	Возврат Результат;

КонецФункции

Функция Добавить(Элемент) Экспорт

	Блокировка.Заблокировать();

	Попытка
		Результат = ВнутреннийСписок.Добавить(Элемент);
	Исключение
		Блокировка.Разблокировать();
		ВызватьИсключение ПодробноеПредставлениеОшибки(ИнформацияОбОшибке());
	КонецПопытки;
	
	Блокировка.Разблокировать();

	Возврат Результат;

КонецФункции

Функция ДобавитьВсе(Коллекция) Экспорт

	Блокировка.Заблокировать();

	Попытка
		Результат = ВнутреннийСписок.ДобавитьВсе(Коллекция);
	Исключение
		Блокировка.Разблокировать();
		ВызватьИсключение ПодробноеПредставлениеОшибки(ИнформацияОбОшибке());
	КонецПопытки;
	
	Блокировка.Разблокировать();

	Возврат Результат;

КонецФункции

Процедура Очистить() Экспорт

	Блокировка.Заблокировать();

	Попытка
		ВнутреннийСписок.Очистить();
	Исключение
		Блокировка.Разблокировать();
		ВызватьИсключение ПодробноеПредставлениеОшибки(ИнформацияОбОшибке());
	КонецПопытки;

	Блокировка.Разблокировать();

КонецПроцедуры

Функция Удалить(Элемент) Экспорт

	Блокировка.Заблокировать();

	Попытка
		Результат = ВнутреннийСписок.Удалить(Элемент);
	Исключение
		Блокировка.Разблокировать();
		ВызватьИсключение ПодробноеПредставлениеОшибки(ИнформацияОбОшибке());
	КонецПопытки;
	
	Блокировка.Разблокировать();

	Возврат Результат;

КонецФункции

Функция УдалитьВсе(Коллекция) Экспорт

	Блокировка.Заблокировать();

	Попытка
		Результат = ВнутреннийСписок.УдалитьВсе(Коллекция);
	Исключение
		Блокировка.Разблокировать();
		ВызватьИсключение ПодробноеПредставлениеОшибки(ИнформацияОбОшибке());
	КонецПопытки;
	
	Блокировка.Разблокировать();

	Возврат Результат;

КонецФункции

Функция УдалитьЕсли(Предикат) Экспорт

	Блокировка.Заблокировать();

	Попытка
		Результат = ВнутреннийСписок.УдалитьЕсли(Предикат);
	Исключение
		Блокировка.Разблокировать();
		ВызватьИсключение ПодробноеПредставлениеОшибки(ИнформацияОбОшибке());
	КонецПопытки;
	
	Блокировка.Разблокировать();

	Возврат Результат;

КонецФункции

Функция СохранитьВсе(Коллекция) Экспорт

	Блокировка.Заблокировать();

	Попытка
		Результат = ВнутреннийСписок.СохранитьВсе(Коллекция);
	Исключение
		Блокировка.Разблокировать();
		ВызватьИсключение ПодробноеПредставлениеОшибки(ИнформацияОбОшибке());
	КонецПопытки;
	
	Блокировка.Разблокировать();

	Возврат Результат;

КонецФункции

Функция Получить(Индекс) Экспорт

	Блокировка.Заблокировать();

	Попытка
		Результат = ВнутреннийСписок.Получить(Индекс);
	Исключение
		Блокировка.Разблокировать();
		ВызватьИсключение ПодробноеПредставлениеОшибки(ИнформацияОбОшибке());
	КонецПопытки;
	
	Блокировка.Разблокировать();

	Возврат Результат;

КонецФункции

Функция Индекс(Элемент) Экспорт

	Блокировка.Заблокировать();

	Попытка
		Результат = ВнутреннийСписок.Индекс(Элемент);
	Исключение
		Блокировка.Разблокировать();
		ВызватьИсключение ПодробноеПредставлениеОшибки(ИнформацияОбОшибке());
	КонецПопытки;
	
	Блокировка.Разблокировать();

	Возврат Результат;

КонецФункции

Функция ПоследнийИндекс(Элемент) Экспорт

	Блокировка.Заблокировать();

	Попытка
		Результат = ВнутреннийСписок.ПоследнийИндекс(Элемент);
	Исключение
		Блокировка.Разблокировать();
		ВызватьИсключение ПодробноеПредставлениеОшибки(ИнформацияОбОшибке());
	КонецПопытки;
	
	Блокировка.Разблокировать();

	Возврат Результат;

КонецФункции

Функция ВГраница() Экспорт

	Блокировка.Заблокировать();

	Попытка
		Результат = ВнутреннийСписок.ВГраница();
	Исключение
		Блокировка.Разблокировать();
		ВызватьИсключение ПодробноеПредставлениеОшибки(ИнформацияОбОшибке());
	КонецПопытки;
	
	Блокировка.Разблокировать();

	Возврат Результат;

КонецФункции

Функция Вставить(Индекс, Элемент) Экспорт

	Блокировка.Заблокировать();

	Попытка
		Результат = ВнутреннийСписок.Вставить(Индекс, Элемент);
	Исключение
		Блокировка.Разблокировать();
		ВызватьИсключение ПодробноеПредставлениеОшибки(ИнформацияОбОшибке());
	КонецПопытки;
	
	Блокировка.Разблокировать();

	Возврат Результат;

КонецФункции

Функция ВставитьВсе(Индекс, Коллекция) Экспорт

	Блокировка.Заблокировать();

	Попытка
		Результат = ВнутреннийСписок.ВставитьВсе(Индекс, Коллекция);
	Исключение
		Блокировка.Разблокировать();
		ВызватьИсключение ПодробноеПредставлениеОшибки(ИнформацияОбОшибке());
	КонецПопытки;
	
	Блокировка.Разблокировать();

	Возврат Результат;

КонецФункции

Процедура ЗаменитьВсе(Алгоритм) Экспорт

	Блокировка.Заблокировать();

	Попытка
		ВнутреннийСписок.ЗаменитьВсе(Алгоритм);
	Исключение
		Блокировка.Разблокировать();
		ВызватьИсключение ПодробноеПредставлениеОшибки(ИнформацияОбОшибке());
	КонецПопытки;

	Блокировка.Разблокировать();

КонецПроцедуры

Процедура Сортировать(СравнениеЗначений) Экспорт

	Блокировка.Заблокировать();

	Попытка
		ВнутреннийСписок.Сортировать(СравнениеЗначений);
	Исключение
		Блокировка.Разблокировать();
		ВызватьИсключение ПодробноеПредставлениеОшибки(ИнформацияОбОшибке());
	КонецПопытки;

	Блокировка.Разблокировать();

КонецПроцедуры

Функция УдалитьПоИндексу(Индекс) Экспорт

	Блокировка.Заблокировать();

	Попытка
		Результат = ВнутреннийСписок.УдалитьПоИндексу(Индекс);
	Исключение
		Блокировка.Разблокировать();
		ВызватьИсключение ПодробноеПредставлениеОшибки(ИнформацияОбОшибке());
	КонецПопытки;
	
	Блокировка.Разблокировать();

	Возврат Результат;

КонецФункции

Функция Установить(Индекс, Значение) Экспорт
	
	Блокировка.Заблокировать();

	Попытка
		Результат = ВнутреннийСписок.Установить(Индекс, Значение);
	Исключение
		Блокировка.Разблокировать();
		ВызватьИсключение ПодробноеПредставлениеОшибки(ИнформацияОбОшибке());
	КонецПопытки;
	
	Блокировка.Разблокировать();

	Возврат Результат;

КонецФункции

&Реализует("Список")
Процедура ПриСозданииОбъекта(Список)
	
	ВнутреннийСписок  = Список;
	Блокировка        = Новый БлокировкаРесурса(ЭтотОбъект);

КонецПроцедуры
